/*  This is a C++ unit for accessing HardInfosAndComputerID.dll v2.0 functions.

         Copyright (C) 2007 -2019 by Cogitosum. All Rights Reserved.

If You have any question mail me at: Cogitosum@onet.eu or Cogitosum@interia.eu
*/


#pragma hdrstop

#include "HardInfosAndComputerID.h"
#include<windows.h>
#pragma hdrstop
#define mydll "..\\HardInfosAndComputerID.dll"

//---------------------------------------------------------------------------

#pragma package(smart_init)

int mpc(char *& dest,char* src)
{ int n;if(src==NULL){dest=NULL;return -1;}
for(int i=0;;i++)if(src[i]==char(0)){n=i+1;break;}
try{ dest=(char*)malloc(n);dest[n-1]=char(0);
strcpy(dest,src);return n;} catch(...){ return 0;}
}
void inttohex(char* x, unsigned l) //for building ID as string in hex with '-'

{ unsigned char * p;
   p=(char*)&l;
for(int i=0;i<4;i++){
                  switch (*p & 15){
                 case 0:x[8-i]='0';break;
                 case 1:x[8-i]='1';break;
                 case 2:x[8-i]='2';break;
                 case 3:x[8-i]='3';break;
                 case 4:x[8-i]='4';break;
                 case 5:x[8-i]='5';break;
                 case 6:x[8-i]='6';break;
                 case 7:x[8-i]='7';break;
                 case 8:x[8-i]='8';break;
                 case 9:x[8-i]='9';break;
                case 10:x[8-i]='A';break;
                case 11:x[8-i]='B';break;
                case 12:x[8-i]='C';break;
                case 13:x[8-i]='D';break;
                case 14:x[8-i]='E';break;
                case 15:x[8-i]='F';break;
                                 }
                      l=l >> 4;
                 }
for(int i=0;i<4;i++){
                  switch (*p & 15){
                 case 0:x[3-i]='0';break;
                 case 1:x[3-i]='1';break;
                 case 2:x[3-i]='2';break;
                 case 3:x[3-i]='3';break;
                 case 4:x[3-i]='4';break;
                 case 5:x[3-i]='5';break;
                 case 6:x[3-i]='6';break;
                 case 7:x[3-i]='7';break;
                 case 8:x[3-i]='8';break;
                 case 9:x[3-i]='9';break;
                case 10:x[3-i]='A';break;
                case 11:x[3-i]='B';break;
                case 12:x[3-i]='C';break;
                case 13:x[3-i]='D';break;
                case 14:x[3-i]='E';break;
                case 15:x[3-i]='F';break;
                                 }
                      l=l >> 4;
                 }
}




//-- var, const, procedure ---------------------------------------------------

        Tid Thardwareinfos::GetComputerID(unsigned l,unsigned fl)
{  if(CID!=NULL) return CID(l,fl); else {Tid x;x.id1=0;x.id2=0;x.id3=0;x.id4=0;x.id5=0;x.id6=0;x.id7=0;x.id8=0;return x;};
//l=0, 32bit key;l=1 64bit key; l=2, 64bit key; l=3, 256bit key
//fl is a flag of bits for code which infos will be taken for building ID
//bits of fl:
//1-  all rom bios , so computerID will be different if anything will change in hardware. bits 2-17,21,23,24 are automaticly set if bit 1 is set (see demo program)
//2-  bios Vendor
//3-  bios version
//4-  bios date
//5-  system model
//6-  system manufacture
//7-  system serial
//8-  system UUID
//9-  sm bios version
//10- sm bios revision
//11- mb model
//12- mb manufacture
//13- mb version
//14- mb serial
//15- cpu name
//16- cpu socketname
//17- cpu manufacture
//18  cpu freq & external freq
//19- cpu id
//20- video card name
//21- mac address
//22- bus slots
//23- mem modules/devices
//24 -31 hdds names and serials 0-7

}
 char * Thardwareinfos::GetComputerIDAsstring(int l,int fl,int & size)
   { if(fidstr==NULL)return NULL;
   Tid x=GetComputerID(l,fl);

   int ll;
   if(l==0){size=9;ll=1;}else if(l==1){size=19;ll=2;}else if(l==2){size=39;ll=4;}else if(l==3){size=79;ll=8;}else {size=0;return NULL;}
   unsigned *p=(unsigned*)&x; // connections between l and numbers of 32bit integers (ll) in ID (1,2,4 or 8) fl and l are here the same like in ComputerID and AllStrID functions
   // format of IDString
   //XXXX-XXXX => (l=0){size=9;ll=1;}
   //XXXX-XXXX-XXXX-XXXX => (l=1){size=19;ll=2;}
   //XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX => (l=2){size=39;ll=4;}
   //XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX => (l=3){size=79;ll=8;}

   for(int i=0;i<ll;i++)inttohex(&fidstr[10*i],p[i]);return fidstr;

   }

     char* Thardwareinfos::GetAllStrId(int fl,int &n)
{  if(allstrid!=NULL) return allstrid(fl,n); else {n=0;return NULL;};

}

     Tid Thardwareinfos::MakeIDFromStr(int lid,int lstr,char *s)
     { if(makeidfromstr!=NULL) return makeidfromstr(lid,lstr,s);else {Tid x;x.id1=0;x.id2=0;x.id3=0;x.id4=0;x.id5=0;x.id6=0;x.id7=0;x.id8=0;return x;};

     }
// code:  TID:id:
// id=ComputerID(l,fl)
//sholud give the same as:
// Tid id ;char* pc; int n;
//pc=GetAllStrID(fl,n);id=MakeIDFromStr(l,n,pc);
// so functions AllstrId and MakeIDFromStr give you access for building ID on your own way making string pc like you want

int n=0;

void addstr(char *&x,char *y) // forr adding strings and char(13) to ConstructorResult
{ int k=0;
 if(y!=NULL){for(int i=0;;i++)if(y[i]==char(0)){k=i;break;}if(k==0)return;
 void *a=realloc(x,n+k+1);if(a!=NULL)x=(char*)a;else return;
 if(n>0){x[n]=char(13); memcpy(&x[n+1],y,k+1);x[n+k+1]=char(0);n=n+k+1;}else {memcpy(&x[0],y,k+1);x[k]=char(0);n=k;}
            }
}


Thardwareinfos::Thardwareinfos(void)
{   struct Tsystemout{
 int lbusslots,lmemMslots,lmemDslots,cpufreqinMHz,cpuexternalfreqinMHz;
   char *cpuname,*cpusocketname,*cpumanuf,*cpuvendor,*cpuid,
 *sysmodel,*sysmanuf,*sysserial,*sysUUID,
 *mbmodel,*mbmanuf,*mbversion,*mbserial,
 *BbDate,*BbVendor,*BbVersion,*SMBbVersion,*SMBbRevision;
void  *memmodules,*memdevices,*sslots;
                     };

typedef _stdcall int(*TGetIdeDiskinfos)(void *& );
typedef _stdcall Tsystemout (*TGetsys)(void);
typedef char *pchar;
typedef _stdcall pchar (*TGetVideoCard)(void);
typedef _stdcall pchar (*TGetBiosMem)(int &);
typedef _stdcall macres ( *TGetMAC)();
typedef _stdcall void (*TAuthorize)(__int64, int ,char *);

TGetsys sys;
Tsystemout ss;
    TGetIdeDiskinfos hdds;
    TGetVideoCard graph,/*biosres,*/lic,ackno;
    TGetMAC mac;
    TGetBiosMem getbiosmem;
    TAuthorize Authorize;

    int n;
    char *pp;
    Tslot **ws;
    TmemDevice **md;
    TmemModule **mm;
    Thdd   **d;

    void *x ;macres m;
  	fvideocard=NULL;fhdds=NULL;fbvendor=NULL;fbversion=NULL;fbdate=NULL;fsysmodel=NULL;
	fsysmanuf=NULL;fsysserial=NULL;fsysUUid=NULL;fsmbversion=NULL;fsmbrevision=NULL;
	fmbmodel=NULL;fmbmanuf=NULL;fmbversion=NULL;fmbserial=NULL;fcpuname=NULL;
	fcpusocket=NULL;fcpumanuf=NULL;fcpuvendor=NULL;fcpuid=NULL;ConstructorResult=NULL;fbiosmem=NULL;;
	  fslots=NULL;fmemM=NULL;fmemD=NULL;CID=NULL;allstrid=NULL;makeidfromstr=NULL;
       	fcpufreqinMhz=0;fbiosmemsize=0;fidstr=(char*)malloc(80);if(fidstr!=NULL){for(int j=0;j<16;j++){for(int i=0;i<4;i++)fidstr[5*j+i]='0';fidstr[j*5+4]='-'; }}
	fcpuextfreqinMHz=0;fslotcount=0;fhddcount=0;fmemMcount=0;fmemDcount=0;
       for(int i=0;i<6;i++)MACAddress[i]=0;flic=NULL;fackno=NULL;

    hDLL = LoadLibrary(mydll); // Note that because the libray is so small and does its job so fast,you can keep it in resourses and
                               //unpack to the hard drive only during constructors of main classes and until you use
                               // functions GetComputerID,GetAllStrID and MakeIDFromStr. After that, dll can be deleted from hdd.
                               // So you can hide that you use any dll:).

  if(hDLL!=NULL)
  {
      x=GetProcAddress(hDLL, "gethardsys");sys=TGetsys(x);
      x=GetProcAddress(hDLL,"gethddsinfos");hdds=TGetIdeDiskinfos(x);
      x=GetProcAddress(hDLL,"getvcard");graph=TGetVideoCard(x);
      x=GetProcAddress(hDLL,"getmacaddress");mac=TGetMAC(x);
      x=GetProcAddress(hDLL,"biosmem");getbiosmem=TGetBiosMem(x);
      x=GetProcAddress(hDLL,"License");lic=TGetVideoCard(x);
      x=GetProcAddress(hDLL,"acknowledgement");ackno=TGetVideoCard(x);

      x=GetProcAddress(hDLL,"MakeIDFromStr");makeidfromstr=TMakeIDFromStr(x);if(x==NULL)addstr(ConstructorResult,"MakeIDFromStr==NULL");
      x=GetProcAddress(hDLL,"ComputerID");CID=TGetComputerID(x);if(x==NULL)addstr(ConstructorResult,"GetComputerID==NULL");
      x=GetProcAddress(hDLL,"AllstrID");allstrid=TAllstrID(x); if(x==NULL)addstr(ConstructorResult,"GetAllStrID==NULL");
      x=GetProcAddress(hDLL,"Authorize");Authorize=TAuthorize(x);  if(x==NULL)addstr(ConstructorResult,"can''t load start procedure");
      for(int i=0;;i++)if(name[i]=='\0'){n=i;break;}
      Authorize(id,n,name);
      if(sys!=NULL) { ss=sys();
mpc(fbvendor,ss.BbVendor);mpc(fbversion,ss.BbVersion);mpc(fbdate,ss.BbDate);
mpc(fsysmodel,ss.sysmodel);mpc(fsysmanuf,ss.sysmanuf);mpc(fsysserial,ss.sysserial);mpc(fsysUUid,ss.sysUUID);
mpc(fsmbversion,ss.SMBbVersion);mpc(fsmbrevision,ss.SMBbRevision);
mpc(fmbmodel,ss.mbmodel);mpc(fmbmanuf,ss.mbmanuf);mpc(fmbversion,ss.mbversion);mpc(fmbserial,ss.mbserial);
mpc(fcpuname,ss.cpuname);mpc(fcpusocket,ss.cpusocketname);mpc(fcpumanuf,ss.cpumanuf);mpc(fcpuvendor,ss.cpuvendor);fcpufreqinMhz=ss.cpufreqinMHz;
fcpuextfreqinMHz=ss.cpuexternalfreqinMHz;mpc(fcpuid,ss.cpuid);

 fslotcount=ss.lbusslots;
if(fslotcount>0)try {fslots=new Tslot[fslotcount];
ws=(Tslot**)ss.sslots;
for(int i=0;i<fslotcount;i++){
mpc(fslots[i].name,ws[i]->name);
fslots[i].usage=ws[i]->usage;
                             }
                }catch(...){addstr(ConstructorResult,"fslots=new Tslot[fslotcount] failed");fslotcount=0;}
fmemMcount=ss.lmemMslots;
if(fmemMcount>0)try{ fmemM=new TmemModule[fmemMcount];mm=(TmemModule**)ss.memmodules;
for(int i=0;i<fmemMcount;i++){mpc(fmemM[i].socket,mm[i]->socket); fmemM[i].size=mm[i]->size;}
                }catch(...){addstr(ConstructorResult,"fmemM=new TmemModule[fmemMcount] failed");fmemMcount=0;}
fmemDcount=ss.lmemDslots;
if(fmemDcount>0)try{ fmemD=new TmemDevice[fmemDcount];
md=(TmemDevice**)ss.memdevices;
for(int i=0;i<fmemDcount;i++){mpc(fmemD[i].DeviceLocator,md[i]->DeviceLocator);mpc(fmemD[i].BankLocator,md[i]->BankLocator);fmemD[i].size=md[i]->size;
                             mpc(fmemD[i].PartNumber,md[i]->PartNumber);mpc(fmemD[i].SerialNumber,md[i]->SerialNumber);mpc(fmemD[i].Manufacturer,md[i]->Manufacturer);}

                }catch(...){addstr(ConstructorResult,"fmemD=new TmemDevice[fmemDcount] failed");fmemDcount=0;}

                  }else addstr(ConstructorResult,"sys==NULL");
if(hdds!=NULL)    {
       fhddcount=hdds((void*)d);if((fhddcount>0)&&(fhddcount<32)){try {fhdds=new Thdd[fhddcount];
  for(int i=0;i<fhddcount;i++){
  mpc(fhdds[i].name,d[i]->name);mpc(fhdds[i].serial,d[i]->serial);mpc(fhdds[i].revision,d[i]->revision);mpc(fhdds[i].logical,d[i]->logical);
  fhdds[i].bps=d[i]->bps;fhdds[i].spt=d[i]->spt;fhdds[i].tpc=d[i]->tpc;fhdds[i].c=d[i]->c;
                             }                                         } catch(...){addstr(ConstructorResult,"fhdds=new Thdd[fhddcount] failed");fhddcount=0;}
                                                                  }else addstr(ConstructorResult,"hddcount out of range");

                  }else addstr(ConstructorResult,"hdd==NULL");
      if(graph!=NULL)mpc(fvideocard,graph());else addstr(ConstructorResult,"graph==NULL");
      if(mac!=NULL) {m=mac();MACAddress[0]=m.id1;MACAddress[1]=m.id2;MACAddress[2]=m.id3;MACAddress[3]=m.id4;MACAddress[4]=m.id5;MACAddress[5]=m.id6; }
                       else {MACAddress[0]=0;MACAddress[1]=0;MACAddress[2]=0;MACAddress[3]=0;MACAddress[4]=0;MACAddress[5]=0;addstr(ConstructorResult,"mac==NULL"); }
      if(getbiosmem!=NULL){ pp=getbiosmem(fbiosmemsize);

            if(fbiosmemsize>0) {try{  fbiosmem=(char*)malloc(fbiosmemsize);
                                 if(fbiosmem!=NULL) memmove(fbiosmem,pp,fbiosmemsize);
                                   }catch(...){fbiosmem=NULL;addstr(ConstructorResult,"malloc failed in fbiosmem");}
                               } else addstr(ConstructorResult,"biosmemsize==0");
                          } else addstr(ConstructorResult,"getbiosmem==NULL");
     if(lic!=NULL)mpc(flic,lic());else addstr(ConstructorResult,"lic==NULL");
     if(ackno!=NULL)mpc(fackno,ackno());else addstr(ConstructorResult,"ackno==NULL");

    //  if(biosres!=NULL)addstr(ConstructorResult,biosres());else {addstr(ConstructorResult,"biosres not available");addstr(ConstructorResult,"biosres not available");addstr(ConstructorResult,"biosres not available");}
    }else {addstr(ConstructorResult,"loading library failed");fhddcount=0;fslotcount=0;fmemMcount=0;fmemDcount=0;}

  }// end of constructor,
//_________________________________________________________________________________________________________________________________________________
Thardwareinfos::~Thardwareinfos(void) {
if(hDLL!=NULL) FreeLibrary(hDLL);
hDLL=NULL;
if(fbvendor!=NULL)free(fbvendor);
if(fbversion!=NULL)free(fbversion);
if(fbdate!=NULL)free(fbdate);
if(fsysmodel!=NULL)free(fsysmodel);
if(fsysmanuf!=NULL)free(fsysmanuf);
if(fsysserial!=NULL)free(fsysserial);
if(fsysUUid!=NULL)free(fsysUUid);
if(fsmbversion!=NULL)free(fsmbversion);
if(fsmbrevision!=NULL)free(fsmbrevision);
if(fmbmodel!=NULL)free(fmbmodel);
if(fmbmanuf!=NULL)free(fmbmanuf);
if(fmbversion!=NULL)free(fmbversion);
if(fmbserial!=NULL)free(fmbserial);
if(fcpuname!=NULL)free(fcpuname);
if(fcpusocket!=NULL)free(fcpusocket);
if(fcpumanuf!=NULL)free(fcpumanuf);
if(fcpuvendor!=NULL)free(fcpuvendor);
if(fcpuid!=NULL)free(fcpuid);
if(ConstructorResult!=NULL)free(ConstructorResult);
if(fbiosmem!=NULL)free(fbiosmem);
if(fidstr!=NULL)free(fidstr);
if(flic!=NULL)free(flic);
if(fackno!=NULL)free(fackno);

for(int i=0;i<fslotcount;i++)
if(fslots[i].name!=NULL)free(fslots[i].name);delete []fslots;
if(fmemM!=NULL){ for(int i=0;i<fmemMcount;i++)if(fmemM[i].socket!=NULL)free(fmemM[i].socket); delete []fmemM;}
if(fmemD!=NULL) {
for(int i=0;i<fmemDcount;i++){if(fmemD[i].DeviceLocator!=NULL)free(fmemD[i].DeviceLocator);if(fmemD[i].BankLocator!=NULL)free(fmemD[i].BankLocator);}
delete []fmemD;}
if(fhdds!=NULL) {
  for(int i=0;i<fhddcount;i++){
  if(fhdds[i].name!=NULL)free(fhdds[i].name); if(fhdds[i].serial!=NULL)free(fhdds[i].serial);if(fhdds[i].revision!=NULL)free(fhdds[i].revision);}
delete []fhdds;}
 }
 void Thardwareinfos::freelib()
 {if(hDLL!=NULL)
 FreeLibrary(hDLL);
 hDLL=NULL;
makeidfromstr=NULL;CID=NULL;allstrid=NULL;
  }

