//---------------------------------------------------------------------------
/*   This is a c++ header file  for accessing HardInfosAndComputerID.dll v2.0 functions.

                        Copyright (C) 2007 - 2019 by Cogitosum. All Rights Reserved.

If You have any question mail me at:  Cogitosum@onet.eu or Cogitosum@interia.eu
*/
__int64 id=50;char *name="+"; //  !!! these two (id and name) should be changed in registered version of library !!!

#include<windows.h>

//#pragma option pop

//#pragma pack(push, 4)
struct Tslot
{     	                         //system slots like isa, pci agp, pci-e and so on.
      int usage;                 // on 64bit Windows usage is often 4 (in use) even if the slot is free. Don't know why.
     char * name;} ;

//#pragma pack(pop)

//#pragma pack(push, 4)
struct TmemModule                // memModules and memDevices contain information about operating memory
{	int size;                // memModules are obsolete, memdevices are newer infos for newer systems
	char * socket;           // The library cancels Tmemmodule infos if bios contains memdivice infos
} ;
//#pragma pack(pop)

//#pragma pack(push, 4)
struct TmemDevice
{
	int size;
	char * DeviceLocator;
	char * BankLocator;
        char * Manufacturer; // sometimes it contains strange things
        char * PartNumber;
        char * SerialNumber; //sometimes not available. In this case it contains 00000000 or FFFFFFFF or None
        };
//#pragma pack(pop)

struct Thdd
{	char * name;
	char * serial;
	char * revision;
        char * logical;       // logical drives created on phisical drive (like c,d,e nd so on)
        unsigned tpc;         // trucks per cylinder, sectors per truck, bytes per sector
        unsigned spt;
        unsigned bps;
        __int64 c;            // count of cylinders. Multiplying of these 4 is a size of physical drive in bytes
} ;
      struct Tid{
               unsigned id1,id2,id3,id4,id5,id6,id7,id8;//ID is up to 8 32 bit unsigned
                  };
      struct macres{unsigned char id1,id2,id3,id4,id5,id6; };// mac address is 6 bytes
typedef char * pchar;
typedef unsigned * punsigned;

typedef _stdcall Tid ( *TGetComputerID)(int,int);
typedef _stdcall pchar (*TAllstrID)(int,int&);
typedef _stdcall Tid (*TMakeIDFromStr)(int ,int ,char *);

class Thardwareinfos
{


private:
 void * hDLL;
 Tslot *fslots;
 TmemModule  *fmemM;
 TmemDevice  *fmemD;
 Thdd        *fhdds;
	char * fvideocard;
	char * fbvendor;              // these infos depends on producer of hardware
	char * fbversion;             //
	char * fbdate;                //  some of them can be not accesible
	char * fsysmodel;             //
	char * fsysmanuf;             //  And for example name of motherboard can be in fmbmodel or in fsysmodel
	char * fsysserial;            //
	char * fsysUUid;              //  so if you want to get motherboard name just read these three fields
	char * fsmbversion;           //
	char * fsmbrevision;          //
	char * fmbmodel;              //
	char * fmbmanuf;              //
	char * fmbversion;            //
	char * fmbserial;             //
	char * fcpuname;              //
	char * fcpusocket;            //
	char * fcpumanuf;             //
	char * fcpuvendor;            //
	char * fcpuid, *ConstructorResult,*fbiosmem,*fidstr, *flic, *fackno;
	int fcpufreqinMhz,fbiosmemsize;
	int fcpuextfreqinMHz;
        int fslotcount,fhddcount,fmemMcount,fmemDcount;
	int  getslotcount(void);
	int  getmemMcount(void);
	int  getmemDcount(void);
	int  getHDDcount(void);
	Tslot  getslot(int i);
	TmemModule getmemM(int i);
	TmemDevice  getmemD(int i);
	Thdd gethdd(int i);
        TGetComputerID CID;
        TAllstrID allstrid;
        TMakeIDFromStr makeidfromstr;
        unsigned char MACAddress[6];
        public:
	 Thardwareinfos(void);
         char *ConstrRes(){return ConstructorResult;}//should return NUL if everything OK else returns short message what was not OK:)
         Tid GetComputerID(unsigned l,unsigned fl);
      char * GetComputerIDAsstring(int l,int fl,int & size);
         Tid MakeIDFromStr(int lid,int lstr,char *s);
         char* GetAllStrId(int fl, int &n);
        void freelib();
	char * BiosVendor(){return fbvendor;};
	char * BiosVersion()  {return fbversion;};
	char * BiosDate()  {return fbdate;};
	char * SystemModel(){return fsysmodel;};
	 char * SystemManufacture() {return fsysmanuf;};
	 char * SystemSerial() {return fsysserial;};
	 char * SystemUUID() {return fsysUUid;};
	 char * SMBiosVersion(){return fsmbversion;};
	 char * SMBrevision(){return fsmbrevision;};
	 char * MainBoardModel(){return fmbmodel;};
	 char * MainBoardSerial(){return fmbserial;};
	 char * MainBoardManufacture(){return fmbmanuf;};
	 char * MainBoardVersion(){return fmbversion;};
	 char * CPUName(){return fcpuname;};
	 char * CPUSocket(){return fcpusocket;};
	 char * CPUManufacture(){return fcpumanuf;};
	 char * CPUVendor(){return fcpuvendor;};
	 char * CPUID(){return fcpuid;};
         char * BiosMem(){return fbiosmem;}
         int BiosMemSize(){return fbiosmemsize;}
	 int CPUFrequencyInMHz(){return fcpufreqinMhz;};
	 int CPUExternalFrequencyInMHz(){return fcpuextfreqinMHz;};
	 int Slotcount(){return fslotcount;};
	 Tslot Slots(int i){if((i>=0)&&(i<fslotcount))return fslots[i];else {Tslot x;x.name=NULL;x.usage=1;return x; }};
	 int MemoryModuleCount(){return fmemMcount;};
	 TmemModule MemoryModules(int i){if((i>=0)&&(i<fmemMcount))return fmemM[i];else{TmemModule x; x.size=0;x.socket=NULL; return x;}};
	 int MemoryDeviceCount(){return fmemDcount;};
	 TmemDevice MemoryDevices(int i){if((i>=0)&&(i<fmemDcount))return fmemD[i];else{TmemDevice x;x.size=0;x.DeviceLocator=NULL;x.BankLocator=NULL;return x;}};
	 int HDDcount(){return fhddcount;};
	 Thdd HDDs(int i){if((i>=0)&&(i<fhddcount))return fhdds[i];else{Thdd x;x.name=NULL;x.serial=NULL;x.revision=NULL;x.bps=0;x.spt=0;x.tpc=0;x.c=0;return x; }};
	 char * VideoCard(){return fvideocard;};
         unsigned char * MAC(){return MACAddress;}   //MAC Address is unique and is properly received only if Net Card is connected to net (router), otherwise it can produce any rubbish
         char* GetLicense(){return flic;}
         char* GetAcknowledgements(){return fackno;}

         //	#pragma option push -w-inl
     virtual ~Thardwareinfos(void);
//	#pragma option pop

};
//---------------------------------------------------------------------------

