unit HardInfosAndComputerID;
{   This is a delphi unit for accessing HardInfosAndComputerID.dll v2.0 functions.

                        Copyright (C) 2007-2019 by Cogitosum. All Rights Reserved.

If You have any question mail me at: MyProgram@onet.eu or Cogitosum@onet.eu or Cogitosum@interia.eu
}
interface
uses windows;
const mydll='..\HardInfosAndComputerID.dll';
var id:int64=50;name:ansistring='+';//  !!! these two (id and name) should be changed in registered version of library !!!
type
 Tslot=record
          name:ansistring;  //system slots like isa, pci agp, pci-e and so on.
          usage:integer;    // on 64bit windows usage is often 4 (in use) even if the slot is free. Don't know why.
       end;
 TmemModule=record
          size:integer;     // memModules and memDevices contain information about operating memory
          socket:ansistring;//memModules are obsolete, memdevices are newer infos for newer systems
            end;            // The library cancels Tmemmodule infos if bios contains memdivice infos
 TmemDevice=record
          size:integer;
          DeviceLocator,BankLocator,partnumber,serialnumber,manufacturer:ansistring;
            end;
 Thdd=record
          name,serial,revision,logical:ansistring; // logical contains letters of logical drives created on phisical drive (like c,d,e nd so on)
              tpc,spt,bps:cardinal;                // trucks per cylinder, sectors per truck,bytes per sector
               c:int64;                            // count of cylinders. Multiplying of these 4 is a size of physical drive in bytes
      end;


TID= array[1..8]of cardinal;// IDComputer binary
Tmacres=array[0..5]of byte; // mac addres of net card binary

  Thardwareinfos=class //main class
private
    fvideocard:ansistring;                                //fvideocard is a graphic card  name got from driver so can change if driver is changed
fbvendor,fbversion,fbdate,                                // these infos depends on producer of hardware
fsysmodel,fsysmanuf,fsysserial,fsysUUid,                  // some of them can be not accesible
fsmbversion,fsmbrevision,                                 // And for example name of motherboard can be in fmbmodel or in fsysmodel
fmbmodel,fmbmanuf,fmbversion,fmbserial,                   // so if you want get motherboard name just read both these fields
fcpuname,fcpusocket,fcpumanuf,fcpuvendor,fcpuid:ansistring;
flicence,facknowledgement :ansistring;
fcpufreqinMhz,fcpuextfreqinMHz:integer;
    fhdds:array of Thdd;
   fslots:array of Tslot;
    fmemM:array of Tmemmodule;
    fmemD:array of Tmemdevice;
hdll:cardinal;
fbiosmem:pansichar;
fbiosmemsize:integer;
fmac:Tmacres;
 funGetcomputerID:function(l,fl:integer):TID;stdcall;
 funGetAllStrID:function(flags:integer;var n:integer):pansichar;stdcall;
 funmakeIDFromStr:function (lID:integer;lStr:integer;s:pansichar):TID;stdcall;
function getslotcount:integer;
function getmemMcount:integer;
function getmemDcount:integer;
function getHDDcount:integer;

function getslot(i:integer):Tslot;
function getmemM(i:integer):Tmemmodule;
function getmemD(i:integer):Tmemdevice;
function gethdd(i:integer):Thdd;

    public
constructorresult:ansistring;  // this string should be empty('') if everything was ok, if not it contains short info what was not ok.
constructor  create;
destructor destroy; override;
procedure freelib;

function GetComputerID(l,fl:cardinal):TID;                      // Just builds computerID. For info of l and fl see body of this function or run demo
function GetComputerIDAsstring(l,fl:integer):string;            // gets Tid as a hex-string with "-"
function GetAllStrID(fl:integer;var n:integer):pansichar;       // gets all string long which is used for ID building and n= length of these datas
function makeIDFromStr(l:integer;lStr:integer;s:pansichar):TID; // fl is the same in these 4 functions, l is the same in 3
                        

property BiosMem:pansichar read fbiosmem;
property BiosMemSize:integer read fbiosmemsize;

property BiosVendor:ansistring read fbvendor;
property BiosVersion:ansistring read fbversion;
property BiosDate:ansistring read fbdate;

property SystemModel:ansistring read fsysmodel;
property SystemManufacture:ansistring read fsysmanuf;
property SystemSerial:ansistring read fsysserial;
property SystemUUID:ansistring read fsysuuid;

property SMBiosVersion:ansistring read fsmbversion;
property SMBrevision:ansistring read fsmbrevision;

property MainBoardModel:ansistring read fmbmodel;
property MainBoardSerial:ansistring read fmbserial;
property MainBoardManufacture:ansistring read fmbmanuf;
property MainBoardVersion:ansistring read fmbversion;

property CPUName:ansistring read fcpuname;
property CPUSocket:ansistring read fcpusocket;
property CPUManufacture:ansistring read fcpumanuf;
property CPUVendor:ansistring read fcpuvendor;
property CPUID:ansistring read fcpuid;
property CPUNFrequencyInMHz:integer read fcpufreqinmhz;
property CPUExternalFrequencyInMHz:integer read fcpuextfreqinmhz;

property Slotcount:integer read getslotcount;
property Slots[i:integer]:Tslot read getslot;

property MemoryModuleCount:integer read getmemMcount;
property MemoryModules[i:integer]:Tmemmodule read getmemM;

property MemoryDeviceCount:integer read getmemDcount;
property MemoryDevices[i:integer]:Tmemdevice read getmemD;

property HDDcount:integer read gethddcount;
property HDDs[i:integer]:Thdd read gethdd;

property VideoCard:ansistring read fvideocard;
property MACAddress: Tmacres read fmac;
property LicenceInfo:ansistring read flicence;
property acknowledgement :ansistring read facknowledgement ;
end;

implementation

procedure inttohex(out x;l:cardinal);
var i:integer;
    p:pbyte;pc:pchar;
begin
   p:=@l;pc:=@x;
for i:=0 to 7 do begin
                 case (p^ and 15) of
                 0:pc[7-i]:='0';
                 1:pc[7-i]:='1';
                 2:pc[7-i]:='2';
                 3:pc[7-i]:='3';
                 4:pc[7-i]:='4';
                 5:pc[7-i]:='5';
                 6:pc[7-i]:='6';
                 7:pc[7-i]:='7';
                 8:pc[7-i]:='8';
                 9:pc[7-i]:='9';
                10:pc[7-i]:='A';
                11:pc[7-i]:='B';
                12:pc[7-i]:='C';
                13:pc[7-i]:='D';
                14:pc[7-i]:='E';
                15:pc[7-i]:='F';
                 end;
                      l:=l shr 4;
                 end;


end;

//our class
procedure Thardwareinfos. freelib;
begin
if hdll<>0 then freelibrary(hdll);hdll:=0;
funGetcomputerid:=nil; funGetAllStrID:=nil;
funmakeIDFromStr:=nil;

end;

constructor Thardwareinfos.create;
type     Tsystemout =record
 lbusslots,lmemMslots,lmemDslots,cpufreqinMHz,cpuexternalfreqinMHz:integer;
                 cpuname,cpusocketname,cpumanuf,cpuvendor,cpuid,
 sysmodel,sysmanuf,sysserial,sysUUID,
 mbmodel,mbmanuf,mbversion,mbserial,
 BbDate,BbVendor,BbVersion,SMBbVersion,SMBbRevision :pansichar;
 memmodules,memdevices,sslots:pointer;
                  end;
  Tslotout=record
            free:integer;
            name:pansichar;
            end;
  TmemMout=record
           size:word;
           socket:pansichar;
           end;
  TmemDout=record
    size:integer;
        DeviceLocator,BankLocator,manufacturer,partnumber,serialnumber:pansichar;
          end;
  Thddout= record
           n,serial,rev,logical:pansichar;
               tpc,spt,bps:cardinal;
               c:int64;

               end;
  phddout=^Thddout;

var     p:ppointerarray;pp:pansichar;
        n,i:integer;
    sys:function:Tsystemout;stdcall;
    hdd:function(var recs:pointer) :integer;stdcall;
    graph,biosres,lic,ackno:function:pansichar;stdcall;
    mac:function:Tmacres;stdcall;
    fungetbiosmem:function(var n:integer):pansichar;stdcall;

    start:procedure(myid:int64;w:integer;name:pansichar);stdcall;
    begin
  hDLL := LoadLibrary(PChar(mydll));// Note that because the libray is so small you can keep it in resourses and unpack to the hard drive
                                    // only during constructors of main classes and until you use functions GetComputerID,GetAllStrID and
                                    // MakeIDFromStr. After that, dll can be deleted from hdd. So you can hide that you use it:).
  if hDLL <> 0 then
  begin
      @sys := GetProcAddress(hDll, pchar('gethardsys'));
      @hdd:=Getprocaddress(hdll,pchar('gethddsinfos'));
      @graph:=Getprocaddress(hdll,pchar('getvcard'));
      @mac:=Getprocaddress(hdll,pchar('getmacaddress'));
   //   @biosres:=Getprocaddress(hdll,pchar('smbiosres'));
      @fungetbiosmem:=Getprocaddress(hdll,pchar('biosmem'));
 @funmakeIDFromStr:=Getprocaddress(hdll,pchar('MakeIDFromStr'));if @funmakeIDFromStr=nil then constructorresult:=constructorresult+'MakeIDFromStr=nil'+#13;
 @funGetComputerID:=Getprocaddress(hdll,pchar('ComputerID'));if @funGetComputerID=nil then constructorresult:=constructorresult+'GetComputerID=nil'+#13;
 @fungetallstrID:=Getprocaddress(hdll,pchar('AllstrID'));if @fungetallstrID=nil then constructorresult:=constructorresult+'GetAllStrID=nil'+#13;

 @lic:=Getprocaddress(hdll,pchar('License'));
 @ackno:=Getprocaddress(hdll,pchar('acknowledgement'));
       @start:=Getprocaddress(hdll,pchar('Authorize'));

    if assigned(start)then   start(id,length(name),pansichar(name));

  	fvideocard:='';fbvendor:='';fbversion:='';fbdate:='';fsysmodel:='';
	fsysmanuf:='';fsysserial:='';fsysUUid:='';fsmbversion:='';fsmbrevision:='';
	fmbmodel:='';fmbmanuf:='';fmbversion:='';fmbserial:='';fcpuname:='';
	fcpusocket:='';fcpumanuf:='';fcpuvendor:='';fcpuid:='';ConstructorResult:='';flicence:='';facknowledgement :='';
	  fhdds:=nil;fslots:=nil;fmemM:=nil;fmemD:=nil;
       	fcpufreqinMhz:=0;
	fcpuextfreqinMHz:=0;
       for i:=0 to 5 do fmac[i]:=0;

      if @sys <> nil then with sys do begin
fbvendor:=bbvendor;fbversion:=bbversion;fbdate:=bbdate;
fsysmodel:=sysmodel;fsysmanuf:=sysmanuf;fsysserial:=sysserial;fsysuuid:=sysuuid;
fsmbversion:=smbbversion;fsmbrevision:=smbbrevision;
fmbmodel:=mbmodel;fmbmanuf:=mbmanuf;fmbversion:=mbversion;fmbserial:=mbserial;
fcpuname:=cpuname;fcpusocket:=cpusocketname;fcpumanuf:=cpumanuf;fcpuvendor:=cpuvendor;fcpufreqinMhz:=cpufreqinMhz;
fcpuextfreqinMHz:=cpuexternalfreqinMHz;
fcpuid:=cpuid;
try setlength(fslots,lbusslots);
p:=sslots;
for i:=0 to lbusslots-1 do with fslots[i] do begin
name:=Tslotout(p[i]^).name;
usage:=Tslotout(p[i]^).free;                 end;except constructorresult:=constructorresult+'setlength(fslots,lbusslots) failed'+#13;end;
try setlength(fmemM,lmemMslots);p:=memmodules;
for i:=0 to lmemMslots-1 do with fmemM[i] do begin socket:=TmemMout(p[i]^).socket; size:=TmemMout(p[i]^).size;end;
except constructorresult:=constructorresult+'setlength(fmemM,lmemMslots) failed'+#13;end;
try setlength(fmemD,lmemDslots);p:=memdevices;
for i:=0 to lmemDslots-1 do with fmemD[i] do begin devicelocator:=TmemDout(p[i]^).devicelocator;banklocator:=TmemDout(p[i]^).banklocator;
                                                   partnumber:=TmemDout(p[i]^).partnumber;serialnumber:=TmemDout(p[i]^).serialnumber;
                                                   manufacturer:=TmemDout(p[i]^).manufacturer;
                                size:=TmemDout(p[i]^).size;
                                             end;
except constructorresult:=constructorresult+'setlength(fmemD,lmemDslots) failed'+#13;end;
                                         end else constructorresult:=constructorresult+'sys=nil'+#13;

if @hdd<>nil then begin
       n:=hdd(pointer(p));
       if(n>0)and(n<16) then begin try setlength(fhdds,n);
  for i:=0 to n-1 do  with  fhdds[i] do begin
  name:=Thddout(p[i]^).n;serial:=Thddout(p[i]^).serial;revision:=Thddout(p[i]^).rev;logical:=Thddout(p[i]^).logical;
                 tpc:=Thddout(p[i]^).tpc;c:=Thddout(p[i]^).c;bps:=Thddout(p[i]^).bps;spt:=Thddout(p[i]^).spt;
                                        end;
                                   except constructorresult:=constructorresult+'setlength(fhdds,n) failed'+#13;end;
                             end else constructorresult:=constructorresult+'hdd count out of range'+#13;
                   end else constructorresult:=constructorresult+'hdd=nil '+#13;
      if @graph<>nil then  fvideocard:=graph else constructorresult:=constructorresult+'graph=nil'+#13;
      if @mac<>nil then  fmac:=mac else constructorresult:=constructorresult+'mac=nil'+#13;
      if @fungetbiosmem<>nil then begin pp:=fungetbiosmem(fbiosmemsize);  //if fbiosmem<>nil then begin freemem(fbiosmem);fbiosmem:=nil;end;
            if fbiosmemsize>0 then begin try getmem(fbiosmem,fbiosmemsize);move(pp^,fbiosmem^,fbiosmemsize);except constructorresult:=constructorresult+'getmem(fbiosmem,fbiosmemsize) failed';fbiosmem:=nil; end;
                                   end ;
                                  end else constructorresult:=constructorresult+'fungetbiosmem=nil'+#13;
//if @biosres<>nil then constructorresult:=constructorresult+biosres else constructorresult:=constructorresult+' biosres not available'+#13;
if @lic<>nil then flicence:=lic else constructorresult:=constructorresult+' can''t take licence, function lic=nil'+#13;
if @ackno<>nil then facknowledgement :=ackno else constructorresult:=constructorresult+' can''t take acknowlagemant, function ackno=nil'+#13;
  end else begin constructorresult:=constructorresult+'loading library failed'+#13;end;


       end;
destructor Thardwareinfos.destroy;
begin
  if hdll<>0 then freelibrary(hdll);
  if fbiosmem<>nil then freemem(fbiosmem);
  inherited;
end;

function Thardwareinfos.gethdd(i: integer): Thdd;
begin
if(i>=0)and(i<length(fhdds))then result:=fhdds[i] else fillchar(result,sizeof(result),0);
end;

function Thardwareinfos.getHDDcount: integer;
begin
result:=length(fhdds);
end;
function Thardwareinfos.GetAllStrID(fl: integer; var n: integer): pansichar;
begin
if @fungetallstrid<>nil then result:=fungetallstrid(fl,n)else begin n:=0;result:=nil;end;
end;
function Thardwareinfos.makeIDFromStr(l: integer; lStr: integer; s: pansichar): TID;
begin
if @funmakeidfromstr<>nil then result:=funmakeidfromstr(l,lstr,s)else fillchar(result,sizeof(result),0);
end;

function Thardwareinfos.GetComputerID(l, fl: cardinal): TID;
begin
if @funGetComputerID<>nil then result:=fungetcomputerid(l,fl) else fillchar(result,sizeof(result),0);
//l=0, 32bit key;l=1 64bit key; l=2, 64bit key; l=3, 256bit key
//bits of fl:
//1-  all rom bios, so computerID will be different if anything will change in hardware. bits 2-17,21,23,24 are automaticly set if bit 1 is set (demo program to see it)
//2-  bios Vendor
//3-  bios version
//4-  bios date
//5-  system model
//6-  system manufacture
//7-  system serial
//8-  system UUID
//9-  sm bios version
//10- sm bios revision
//11- mb model
//12- mb manufacture
//13- mb version
//14- mb serial
//15- cpu name
//16- cpu socketname
//17- cpu manufacture
//18  cpu freq & external freq
//19- cpu id
//20- video card name
//21- mac address
//22- bus slots
//23- mem modules/devices
//24 -31 hdds names and serials 0-7



end;

// code: var id:TID
//begin id:=GetcomputerID(l,fl);end
//sholud give the same as:
// var id:Tid;pc:pchar;n:integer;
//begin pc:=GetAllStrID(fl,n);id:=makeIDFromStr(l,n,pc);   end;
// so functions GetAllstrId and makeIDFromStr give you access for building ID on your own way making string pc like you want
function Thardwareinfos.GetComputerIDAsstring(l, fl: integer):string;
var i,ll:integer;
     id:tid;s:string;
begin ll:=2;
 case l of
0:ll:=1; // connections between l and numbers of 32bit integers (ll) in ID (1,2,4 or 8) fl and l are here the same like in GetComputerID and GetAllStrID functions
1:ll:=2;
2:ll:=4;
3:ll:=8;
end;// format of IDString
   //XXXX-XXXX => (l=0){size=9;ll=1;}
   //XXXX-XXXX-XXXX-XXXX => (l=1){size=19;ll=2;}
   //XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX => (l=2){size=39;ll=4;}
   //XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX-XXXX => (l=3){size=79;ll=8;}

id:=GetComputerID(l, fl);
                     setlength(s,8);
result:='';for i:=1 to ll-1 do begin
                       inttohex(s[1],id[i]);
                       result:=result+copy(s,1,4)+'-'+copy(s,5,4)+'-';
                               end;
                       inttohex(s[1],id[ll]);
                       result:=result+copy(s,1,4)+'-'+copy(s,5,4);
                             end;
function Thardwareinfos.getmemD(i:integer): Tmemdevice;
begin if(i>=0)and(i<length(fmemD)) then result:=fmemd[i]else fillchar(result,sizeof(result),0)
end;

function Thardwareinfos.getmemDcount: integer;
begin
result:=length(fmemd);
end;

function Thardwareinfos.getmemM(i:integer): Tmemmodule;
begin
if(i>=0)and(i<length(fmemM)) then result:=fmemM[i]else fillchar(result,sizeof(result),0);
end;

function Thardwareinfos.getmemMcount: integer;
begin
result:=length(fmemM);
end;

function Thardwareinfos.getslot(i:integer): Tslot;
begin
if(i>=0)and(i<length(fslots)) then result:=fslots[i]else fillchar(result,sizeof(result),0);
end;

function Thardwareinfos.getslotcount: integer;
begin
result:=length(fslots);
end;

end.
